SystemOrganization addCategory: #'Gradualtalk-Parser'!

!Metaclass methodsFor: '*Gradualtalk-Parser--initialize-release' stamp: 'EstebanAllende 12/7/2011 00:30'!
instanceVariableNames: instVarString 
	"Declare additional named variables for my instance."
	|varParser res|
	varParser :=( (VariablesParser new)
		class: self;
		ivar: instVarString).
	res :=(ClassBuilder new)
		class: self
		instanceVariableNames: varParser oldIvar.
	varParser annotateVars.
	^res.! !

!OCParser methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 12/6/2011 14:01'!
realParserClass

	^ PPTypedSmalltalkParser! !

PPCompositeParser subclass: #PPBaseSmalltalkGrammar
	instanceVariableNames: 'array arrayItem arrayLiteral arrayLiteralArray assignment assignmentToken binary binaryExpression binaryMessage binaryMethod binaryPragma binaryToken block blockArgument blockArguments blockArgumentsWith blockArgumentsWithout blockBody byteLiteral byteLiteralArray cascadeExpression cascadeMessage char charLiteral charToken expression falseLiteral falseToken identifier identifierToken keyword keywordExpression keywordMessage keywordMethod keywordPragma keywordToken literal message method methodDeclaration methodSequence multiword nilLiteral nilToken number numberLiteral numberToken parens period periodToken pragma pragmaMessage pragmas primary return sequence startExpression startMethod statements string stringLiteral stringToken symbol symbolLiteral symbolLiteralArray temporaries trueLiteral trueToken unary unaryExpression unaryMessage unaryMethod unaryPragma unaryToken variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!PPBaseSmalltalkGrammar commentStamp: '<historical>' prior: 0!
A parser for Smalltalk methods and expressions.!

!PPBaseSmalltalkGrammar class methodsFor: 'testing' stamp: 'EstebanAllende 11/27/2011 18:59'!
allowUnderscoreAssignment
	^ Scanner allowUnderscoreAsAssignment! !

!PPBaseSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseExpression: aString
	^ self new parseExpression: aString! !

!PPBaseSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseExpression: aString onError: aBlock
	^ self new parseExpression: aString onError: aBlock! !

!PPBaseSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseMethod: aString
	^ self new parseMethod: aString! !

!PPBaseSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseMethod: aString onError: aBlock
	^ self new parseMethod: aString onError: aBlock! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
array
	^ ${ asParser smalltalkToken , (expression delimitedBy: periodToken) optional , $} asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
arrayItem
	^ literal / symbolLiteralArray / arrayLiteralArray / byteLiteralArray! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
arrayLiteral
	^ '#(' asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
arrayLiteralArray
	^ $( asParser smalltalkToken , arrayItem star , $) asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
assignment
	^ variable , assignmentToken! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
assignmentToken
	^ self class allowUnderscoreAssignment
		ifTrue: [ (':=' asParser / '_' asParser) smalltalkToken ]
		ifFalse: [ ':=' asParser smalltalkToken ]! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
binary
	^ (PPPredicateObjectParser anyOf: '!!%&*+,-/<=>?@\|~') plus! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
binaryExpression
	^ unaryExpression , binaryMessage star! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
binaryMessage
	^ (binaryToken , unaryExpression) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 11/27/2011 18:59'!
binaryMethod
	^ (binaryToken , variable) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 11/27/2011 18:59'!
binaryPragma
	^ (binaryToken , arrayItem) ==> [ :nodes | 
		Array 
			with: (Array with: nodes first)
			with: (Array with: nodes second) ]! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
binaryToken
	^ binary smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
block
	^ $[ asParser smalltalkToken , blockBody , $] asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
blockArgument
	^ $: asParser smalltalkToken , variable! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
blockArguments
	^ blockArgumentsWith / blockArgumentsWithout! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
blockArgumentsWith
	^ blockArgument plus , ($| asParser smalltalkToken / ($] asParser smalltalkToken and ==> [ :node | nil ]))! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
blockArgumentsWithout
	^ nil asParser ==> [ :nodes | Array with: #() with: nil ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
blockBody
	^ blockArguments , sequence! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
byteLiteral
	^ '#[' asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
byteLiteralArray
	^ $[ asParser smalltalkToken , numberLiteral star , $] asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
cascadeExpression
	^ keywordExpression , cascadeMessage star! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
cascadeMessage
	^ $; asParser smalltalkToken , message! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
char
	^ $$ asParser , #any asParser! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
charLiteral
	^ charToken! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
charToken
	^ char smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
expression
	^ assignment star , cascadeExpression! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
falseLiteral
	^ falseToken! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
falseToken
	^ ('false' asParser , #word asParser not) smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
identifier
	^ self class allowUnderscoreAssignment
		ifTrue: [ #letter asParser , #word asParser star ]
		ifFalse: [
			(PPPredicateObjectParser
				on: [ :each | each isLetter or: [ each = $_ ] ]
				message: 'letter expected') ,
			(PPPredicateObjectParser
				on: [ :each | each isAlphaNumeric or: [ each = $_ ] ]
				message: 'letter or digit expected') star ]! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
identifierToken
	^ identifier smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
keyword
	^ identifier , $: asParser! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
keywordExpression
	^ binaryExpression , keywordMessage optional! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
keywordMessage
	^ (keywordToken , binaryExpression) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 11/27/2011 18:59'!
keywordMethod
	^ (keywordToken , variable) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 11/27/2011 18:59'!
keywordPragma
	^ (keywordToken , arrayItem) plus ==> [ :nodes | 
		Array 
			with: (nodes collect: [ :each | each first ])
			with: (nodes collect: [ :each | each second ]) ]! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
keywordToken
	^ keyword smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
literal
	^ numberLiteral / stringLiteral / charLiteral / arrayLiteral / byteLiteral / symbolLiteral / nilLiteral / trueLiteral / falseLiteral! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
message
	^ keywordMessage / binaryMessage / unaryMessage! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
method
	^ methodDeclaration , methodSequence! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
methodDeclaration
	^ keywordMethod / unaryMethod / binaryMethod! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
methodSequence
	^ periodToken star , pragmas , periodToken star , temporaries , periodToken star , pragmas , periodToken star , statements! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
multiword
	^ keyword plus! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
nilLiteral
	^ nilToken! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
nilToken
	^ ('nil' asParser , #word asParser not) smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
number
	^ ($- asParser optional , #digit asParser) and , [ :stream | 
		[ Number readFrom: stream ] 
			on: Error
			do: [ :err | PPFailure message: err messageText at: stream position ] ] 
				asParser! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
numberLiteral
	^ numberToken! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
numberToken
	^ number smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
parens
	^ $( asParser smalltalkToken , expression , $) asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseExpression: aString 
	^ self parseExpression: aString onError: [ :msg :pos | self error: msg ]! !

!PPBaseSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseExpression: aString onError: aBlock
	^ startExpression parse: aString onError: aBlock! !

!PPBaseSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseMethod: aString 
	^ self parseMethod: aString onError: [ :msg :pos | self error: msg ]! !

!PPBaseSmalltalkGrammar methodsFor: 'parsing' stamp: 'EstebanAllende 11/27/2011 18:59'!
parseMethod: aString onError: aBlock
	^ startMethod parse: aString onError: aBlock! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
period
	^ $. asParser! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
periodToken
	^ period smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
pragma
	^ $< asParser smalltalkToken , pragmaMessage , $> asParser smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 11/27/2011 18:59'!
pragmaMessage
	^ keywordPragma / unaryPragma / binaryPragma! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
pragmas
	^ pragma star! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
primary
	^ literal / variable / block / parens / array! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
return
	^ $^ asParser smalltalkToken , expression! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
sequence
	^ temporaries , periodToken star , statements! !

!PPBaseSmalltalkGrammar methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
start
	"Default start production."

	^ startMethod! !

!PPBaseSmalltalkGrammar methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
startExpression
	"Start production for the expression."

	^ sequence end! !

!PPBaseSmalltalkGrammar methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
startMethod
	"Start production for the method."

	^ method end! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 1/18/2013 12:26'!
statements
	^ 	(expression wrapped , ((periodToken plus , statements ==> [ :nodes | nodes first , nodes last ])
								/ periodToken star)
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	(return , periodToken star
			==> [ :nodes | (Array with: nodes first) , (nodes last) ])
	/	(periodToken star)! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
string
	^ $' asParser , ('''''' asParser / $' asParser negate) star , $' asParser! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
stringLiteral
	^ stringToken! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
stringToken
	^ string smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
symbol
	^ unary / binary / multiword / string! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
symbolLiteral
	"This is totally fucked up: The Pharo compiler allows multiple #, arbitrary spaces between the # and the symbol, as well as comments inbetween. And yes, it is used."

	^ $# asParser smalltalkToken plus , symbol smalltalkToken ==> [ :tokens | tokens first copyWith: tokens last ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
symbolLiteralArray
	^ symbol smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
temporaries
	^ ($| asParser smalltalkToken , variable star , $| asParser smalltalkToken) optional ==> [ :nodes | nodes ifNil: [ #() ] ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
trueLiteral
	^ trueToken! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
trueToken
	^ ('true' asParser , #word asParser not) smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'primitives' stamp: 'EstebanAllende 11/27/2011 18:59'!
unary
	^ identifier , $: asParser not! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
unaryExpression
	^ primary , unaryMessage star! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
unaryMessage
	^ unaryToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 11/27/2011 18:59'!
unaryMethod
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: Array new ]! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar-pragmas' stamp: 'EstebanAllende 11/27/2011 18:59'!
unaryPragma
	^ identifierToken ==> [ :node | 
		Array 
			with: (Array with: node)
			with: (Array new) ]! !

!PPBaseSmalltalkGrammar methodsFor: 'token' stamp: 'EstebanAllende 11/27/2011 18:59'!
unaryToken
	^ unary smalltalkToken! !

!PPBaseSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
variable
	^ identifierToken! !

PPBaseSmalltalkGrammar subclass: #PPTypedSmalltalkGrammar
	instanceVariableNames: 'type parenType cast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

PPTypedSmalltalkGrammar class
	instanceVariableNames: 'typeGrammar parenToken parenType castBracketType bootstrapType'!

PPTypedSmalltalkGrammar class
	instanceVariableNames: 'typeGrammar parenToken parenType castBracketType bootstrapType'!

PPTypedSmalltalkGrammar subclass: #PPBaseSmalltalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!PPBaseSmalltalkParser commentStamp: '<historical>' prior: 0!
Enhances the Smalltalk grammar with production actions to build parse-tree nodes of the refactoring browser.!

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
addStatements: aCollection into: aNode
	aCollection isNil 
		ifTrue: [ ^ aNode ].
	aCollection do: [ :each |
		each class == PPSmalltalkToken
			ifFalse: [ aNode addNode:  each ]
			ifTrue: [
				aNode statements isEmpty
					ifTrue: [ aNode addComments: each comments ]
					ifFalse: [ aNode statements last addComments: each comments ].
				aNode periods: (aNode periods asOrderedCollection
					addLast: each start;
					yourself) ] ].
	^ aNode! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
array
	^ super array map: [ :openNode :statementNodes :closeNode |
		(self buildArray: statementNodes)
			left: openNode start;
			right: closeNode start;
			yourself ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
arrayLiteral
	^ super arrayLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
arrayLiteralArray
	^ super arrayLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: false ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
binaryExpression
	^ super binaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
block
	^ super block map: [ :leftToken :blockNode :rightToken | blockNode left: leftToken start; right: rightToken start ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-blocks' stamp: 'EstebanAllende 11/27/2011 18:59'!
blockBody
	^ super blockBody ==> [ :nodes | 
		| result |
		result := RBBlockNode arguments: nodes first first body: nodes last.
		nodes first last isNil
			ifFalse: [ result bar: nodes first last start ].
		result ]! !

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
build: aNode assignment: anArray
	^ anArray isEmpty
		ifTrue: [ aNode ]
		ifFalse: [
			anArray reverse 
				inject: aNode
				into: [ :result :each |
					RBAssignmentNode 
						variable: each first
						value: result
						position: each second start ] ]! !

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
build: aNode cascade: anArray 
	| messages semicolons |
	^ (anArray isNil or: [ anArray isEmpty ]) 
		ifTrue: [ aNode ]
		ifFalse: [
			messages := OrderedCollection new: anArray size + 1.
			messages addLast: aNode.
			semicolons := OrderedCollection new.
			anArray do: [ :each | 
				messages addLast: (self 
					build: aNode receiver
					messages: (Array with: each second)).
				semicolons addLast: each first start ].
			RBCascadeNode messages: messages semicolons: semicolons ]! !

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
build: aNode messages: anArray 
	^ (anArray isNil or: [ anArray isEmpty ]) 
		ifTrue: [ aNode ]
		ifFalse: [
			anArray 
				inject: aNode
				into: [ :rec :msg | 
					msg isNil 
						ifTrue: [ rec ]
						ifFalse: [
							RBMessageNode 
								receiver: rec
								selectorParts: msg first
								arguments: msg second ] ] ]! !

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
build: aTempCollection sequence: aStatementCollection
	| result |
	result := self
		addStatements: aStatementCollection
		into: RBSequenceNode new.
	aTempCollection isEmpty ifFalse: [
		result
			leftBar: aTempCollection first start
			temporaries: aTempCollection second
			rightBar: aTempCollection last start ].
	^ result! !

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
buildArray: aStatementCollection
	^ self addStatements: aStatementCollection into: RBArrayNode new! !

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
buildMethod: aMethodNode
	aMethodNode selectorParts 
		do: [ :each | aMethodNode addComments: each comments ].
	aMethodNode arguments
		do: [ :each | aMethodNode addComments: each token comments ].
	aMethodNode pragmas do: [ :pragma |
		aMethodNode addComments: pragma comments.
		pragma selectorParts 
			do: [ :each | aMethodNode addComments: each comments ].
		pragma arguments do: [ :each | 
			each isLiteralArray
				ifFalse: [ aMethodNode addComments: each token comments ] ].
		pragma comments: nil ].
	^ aMethodNode! !

!PPBaseSmalltalkParser methodsFor: 'private' stamp: 'EstebanAllende 11/27/2011 18:59'!
buildString: aString 
	(aString isEmpty or: [ aString first ~= $' or: [ aString last ~= $' ] ])
		ifTrue: [ ^ aString ].
	^ (aString 
		copyFrom: 2
		to: aString size - 1) 
		copyReplaceAll: ''''''
		with: ''''! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
byteLiteral
	^ super byteLiteral ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
byteLiteralArray
	^ super byteLiteralArray ==> [ :nodes | RBLiteralArrayNode startPosition: nodes first start contents: nodes second stopPosition: nodes last start isByteArray: true ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
cascadeExpression
	^ super cascadeExpression map: [ :receiverNode :messageNodes | self build: receiverNode cascade: messageNodes ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
charLiteral
	^ super charLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: token value second start: token start stop: token stop) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
expression
	^ super expression map: [ :variableNodes :expressionNodes | self build: expressionNodes assignment: variableNodes ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
falseLiteral
	^ super falseLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: false start: token start stop: token stop) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
keywordExpression
	^ super keywordExpression map: [ :receiveNode :messageNode | self build: receiveNode messages: (Array with: messageNode) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
method
	^ super method map: [ :methodNode :bodyNode | 
		methodNode pragmas: bodyNode first.
		methodNode body: bodyNode second.
		self buildMethod: methodNode ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
methodSequence
	^ super methodSequence map: [ :periodNodes1 :pragmaNodes1 :periodNodes2 :tempNodes :periodNodes3 :pragmaNodes2 :periodNodes4 :statementNodes |
		Array
			with: pragmaNodes1 , pragmaNodes2
			with: (self build: tempNodes sequence: periodNodes1 , periodNodes2 , periodNodes3 , periodNodes4 , statementNodes) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
nilLiteral
	^ super nilLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: nil start: token start stop: token stop) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
numberLiteral
	^ super numberLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBNumberLiteralToken value: (Number readFrom: token value) start: token start stop: token stop source: token value) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
pragma
	^ super pragma ==> [ :nodes | 
		(RBPragmaNode selectorParts: nodes second first arguments: nodes second second)
			addComments: nodes first comments;
			addComments: nodes last comments;
			left: nodes first start;
			right: nodes last start;
			yourself ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
return
	^ super return map: [ :token :expressionNode | RBReturnNode return: token start value: expressionNode ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
sequence
	^ super sequence map: [ :tempNodes :periodNodes :statementNodes | self build: tempNodes sequence: periodNodes , statementNodes ]! !

!PPBaseSmalltalkParser methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
startExpression
	"Make the sequence node has a method node as its parent and that the source is set."

	^ ([ :stream | stream collection ] asParser and , super startExpression) map: [ :source :node | 
		(RBMethodNode selector: #doIt body: node)
			source: source.
		(node statements size = 1 and: [ node temporaries isEmpty ])
			ifTrue: [ node statements first ]
			ifFalse: [ node ] ]! !

!PPBaseSmalltalkParser methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 18:59'!
startMethod
	"Make sure the method node has the source code properly set."
	
	^ ([ :stream | stream collection ] asParser and , super startMethod)
		map: [ :source :node | node source: source ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
stringLiteral
	^ super stringLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: (self buildString: token value) start: token start stop: token stop) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
symbolLiteral
	^ super symbolLiteral ==> [ :tokens | RBLiteralValueNode literalToken: (RBLiteralToken value: (self buildString: tokens last value) asSymbol start: tokens first start stop: tokens last stop) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
symbolLiteralArray
	^ super symbolLiteralArray ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: (self buildString: token value) asSymbol start: token start stop: token stop) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-literals' stamp: 'EstebanAllende 11/27/2011 18:59'!
trueLiteral
	^ super trueLiteral ==> [ :token | RBLiteralValueNode literalToken: (RBLiteralToken value: true start: token start stop: token stop) ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar-messages' stamp: 'EstebanAllende 11/27/2011 18:59'!
unaryExpression
	^ super unaryExpression map: [ :receiverNode :messageNodes | self build: receiverNode messages: messageNodes ]! !

!PPBaseSmalltalkParser methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 18:59'!
variable
	^ super variable ==> [ :token | RBVariableNode identifierToken: token ]! !

PPBaseSmalltalkParser subclass: #PPTypedSmalltalkParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

PPTypedSmalltalkParser class
	instanceVariableNames: 'typeParser dynType'!

PPTypedSmalltalkParser class
	instanceVariableNames: 'typeParser dynType'!

!PPTypedSmalltalkParser class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 19:17'!
dynType

	^ dynType! !

!PPTypedSmalltalkParser class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 19:17'!
dynType: anObject

	dynType := anObject! !

!PPTypedSmalltalkParser class methodsFor: 'accessing' stamp: 'EstebanAllende 12/7/2011 00:44'!
initialize
	super initialize.
	dynType ifNil: [dynType := Object].! !

!PPTypedSmalltalkParser class methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 11:57'!
type
	^OTCSupport bootstrapping 
		ifFalse: [typeParser]
		ifTrue: [bootstrapType].! !

!PPTypedSmalltalkParser class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 19:15'!
typeParser

	^ typeParser! !

!PPTypedSmalltalkParser class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 19:15'!
typeParser: anObject

	typeParser := anObject! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/6/2011 22:12'!
blockArgument
	^ super blockArgument
		==> [:nodes | nodes third propertyAt: #type put: (nodes second ifNil: [PPTypedSmalltalkParser dynType]) ; yourself]! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/6/2011 16:46'!
build: aTempCollection sequence: aStatementCollection
	| result |
	result := self
		addStatements: aStatementCollection
		into: RBSequenceNode new.
	aTempCollection isEmpty ifFalse: [
		result
			leftBar: aTempCollection first start
			temporaries: (aTempCollection second collect: [:nodes | nodes second propertyAt:#type put: (nodes first ifNil:[PPTypedSmalltalkParser dynType]); yourself]) 
			rightBar: aTempCollection last start ].
	^ result! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 20:10'!
cast
	^ super cast ==> [:nodes| {nodes second. nodes first start. nodes last stop}]! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 20:23'!
classVariableParser
	^ super classVariableGrammar! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 20:13'!
methodDeclaration
	^ super methodDeclaration
		==> [:nodes | RBMethodNode selectorParts: nodes first arguments: nodes second paramTypes: nodes third returnType:  nodes fourth]! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 10/5/2012 21:10'!
parametricVariableParser
	"^ (variable, ('<:' asParser, type) optional) star"
	^ super parametricVariableGrammar ==> [:nodes| nodes collect: [:each| {each second ifNotNil: [each second second]. each first}]]! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 20:15'!
parenType
	^ super parenType ==> [:nodes |
		"|parenList|
		parenList := nodes second parens.
		parenList addFirst: nodes first.
		parenList addLast: nodes last."
		nodes second 
		]! !

!PPTypedSmalltalkParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/5/2011 16:59'!
parens
	^ super parens
		map: [:openToken :castExpr :expressionNode :closeToken | 
			expressionNode
				addParenthesis: (openToken start to: closeToken start).
			castExpr ifNotNil: [
				 CastExpr addCast: (CastExpr explicitToType: castExpr first) to: expressionNode].
			expressionNode]! !

!PPTypedSmalltalkGrammar class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 15:14'!
bootstrapType
	^((parenToken negate star), (parenType / castBracketType / '->' asParser)) star, (parenToken negate star)
	! !

!PPTypedSmalltalkGrammar class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 20:47'!
castBracketType

	^$< asParser, self type, $> asParser! !

!PPTypedSmalltalkGrammar class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 12:06'!
initialize
	bootstrapType := PPUnresolvedParser new.
	parenToken := PPUnresolvedParser new.
	castBracketType := PPUnresolvedParser new.
	parenType := PPUnresolvedParser new.
	bootstrapType def: self bootstrapType.
	parenToken def: self parenToken.
	castBracketType def: self castBracketType.
	parenType def: self parenType.
	! !

!PPTypedSmalltalkGrammar class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 15:05'!
parenToken
	^($( asParser / $) asParser / $< asParser / $> asParser)
	! !

!PPTypedSmalltalkGrammar class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 19:29'!
parenType

	^$( asParser, self type, $) asParser! !

!PPTypedSmalltalkGrammar class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 21:00'!
type
	^OTCSupport bootstrapping 
		ifFalse: [typeGrammar]
		ifTrue: [bootstrapType].! !

!PPTypedSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 19:15'!
typeGrammar

	^ typeGrammar! !

!PPTypedSmalltalkGrammar class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 20:58'!
typeGrammar: anObject

	typeGrammar := anObject.
	self initialize.! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 11/27/2011 19:58'!
binaryMethod
	^ parenType optional , binaryToken , parenType optional , variable
		==> [:nodes | Array
				with: (Array with: nodes second)
				with: (Array with: nodes fourth)
				with: {nodes third}
				with: (nodes first)]! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar-types' stamp: 'EstebanAllende 11/27/2011 19:48'!
blockArgument
	^ $: asParser smalltalkToken , parenType optional, variable! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar-types' stamp: 'EstebanAllende 11/27/2011 19:47'!
cast
	^$< asParser smalltalkToken, type, $> asParser smalltalkToken! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 19:59'!
classVariableGrammar
	^  (parenType optional , variable) star ! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 11/27/2011 19:57'!
keywordMethod
	^ parenType optional , (keywordToken , parenType optional , variable) plus
		==> [:nodes | Array
				with: (nodes second
						collect: [:each | each first])
				with: (nodes second
						collect: [:each | each third])
				with: (nodes second
						collect: [:each | each second])
				with: (nodes first)]! !

!PPTypedSmalltalkGrammar methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 10/5/2012 21:09'!
parametricVariableGrammar
	"^  (parenType optional , variable) star "
	^ (variable, ('<:' asParser, type) optional) star! !

!PPTypedSmalltalkGrammar methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 19:30'!
parenType
	^ self class parenType.! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 19:59'!
parens
	^ $( asParser smalltalkToken , cast optional, expression , $) asParser smalltalkToken! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar' stamp: 'EstebanAllende 11/27/2011 20:00'!
temporaries
	^ ($| asParser smalltalkToken , (parenType optional, variable) star , $| asParser smalltalkToken) optional
		==> [:nodes | nodes
				ifNil: [#()]]! !

!PPTypedSmalltalkGrammar methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 19:30'!
type
	^ self class type.! !

!PPTypedSmalltalkGrammar methodsFor: 'grammar-methods' stamp: 'EstebanAllende 11/27/2011 19:56'!
unaryMethod
	^ parenType optional, identifierToken
		==> [:nodes | Array
				with: (Array with: nodes second)
				with: Array new
				with: Array new
				with: (nodes first)]! !

!RBMethodNode class methodsFor: '*Gradualtalk-Parser--instance creation' stamp: 'EstebanAllende 12/6/2011 16:57'!
selectorParts: tokenCollection arguments: variableNodes paramTypes: paramTypes returnType:  returnType
	|node|
	node:=self selectorParts: tokenCollection arguments: variableNodes .
	
	node propertyAt: #returnType put: (returnType ifNil:[PPTypedSmalltalkParser dynType]).
	1 to: variableNodes size do: [:idx | (variableNodes at: idx) propertyAt: #type put: ((paramTypes at: idx) ifNil:[PPTypedSmalltalkParser dynType])].
	
	^ node! !

Object subclass: #VariablesParser
	instanceVariableNames: 'ivar cvar parser paramParser class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Parser'!

!VariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/7/2011 00:37'!
annotateVars
	|dict classRef dynType|
	"classRef := Smalltalk at: class."
	OTCSupport bootstrapping ifTrue: [^self].
	class isSymbol ifTrue: [class := Smalltalk at: class].
	dict := (Smalltalk at: #TypeDictionary) uniqueInstance. 
	dynType := (Smalltalk at: #Type) defaultType.
	dict emptyVariableDictionaryInClass: class.
	ivar do: [:var| dict class: class atInstVar: var second name putType: (var first ifNil: [dynType])].
	cvar do: [:var| dict class: class atClassVar: var second name putType: (var first ifNil: [dynType])].! !

!VariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:46'!
class: aSymbol
	class := aSymbol.! !

!VariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:47'!
cvar: aString
	cvar := parser parse: aString.! !

!VariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 10/5/2012 21:11'!
initialize
	parser := PPTypedSmalltalkParser new classVariableParser.
	paramParser :=  PPTypedSmalltalkParser new classVariableParser end / PPTypedSmalltalkParser new parametricVariableParser end.
	cvar := #().
	ivar := #().! !

!VariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:46'!
ivar: aString
	ivar := parser parse: aString.! !

!VariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:47'!
oldCvar
	^' ' join: (cvar collect: [:each| each second name])! !

!VariablesParser methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/28/2011 01:47'!
oldIvar
	^' ' join: (ivar collect: [:each| each second name])! !

!ClassDescription methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 12/7/2011 01:05'!
classVariablesString
	"Answer a string of my class variable names separated by spaces."

	^String streamContents: [ :stream | 
		self classVarNames 
			do: [ :each | stream nextPutAll: (self printClassVariable: each) ]
			separatedBy: [ stream space ] ]! !

!ClassDescription methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 12/7/2011 01:05'!
instanceVariablesString
	"Answer a string of my instance variable names separated by spaces."
	

	^String streamContents: [ :stream |
		self instVarNames 
			do: [ :each | stream nextPutAll: (self printInstanceVariable: each) ]
			separatedBy: [ stream space ] ]! !

!ClassDescription methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 12/7/2011 01:04'!
printClassVariable: varName

	|type|
	type :=  OTCSupport bootstrapping 
					ifTrue: [nil]
					ifFalse: [TypeDictionary uniqueInstance class: self atClassVar: varName].
	^type ifNil:[varName]
		   ifNotNil: [(type isDyn and: [type implicit]) ifFalse: ['(', (type asString) , ')', varName] ifTrue:[varName]] ! !

!ClassDescription methodsFor: '*Gradualtalk-Parser' stamp: 'EstebanAllende 12/7/2011 01:04'!
printInstanceVariable: varName

	|type|
	type :=  OTCSupport bootstrapping 
					ifTrue: [nil]
					ifFalse: [TypeDictionary uniqueInstance class: self atInstVar: varName].
	^type ifNil:[varName]
		   ifNotNil: [(type isDyn and: [type implicit]) ifFalse: ['(', (type asString) , ')', varName] ifTrue:[varName]] ! !
PPTypedSmalltalkGrammar initialize!
PPTypedSmalltalkParser initialize!
